<template>
  <JMenu :close-on-click="false">
    <template #activator="menuProps">
      <JKeyboardNavItem #default="a11yProps">
        <div class="chat-system-message">
          <JText
            tag="div"
            type="text-4"
            color="third-text"
            weight="normal"
            class="time"
          >
            <MessageTime
              only-format
              hide-updated-label
              :message="message"
            />
          </JText>
          <JText
            v-if="hideAuthor === false"
            v-bind="mergeProps(menuProps, a11yProps)"
            tag="span"
            color="primary"
            weight="normal"
            type="text-2"
            class="author-chat-message"
          >
            {{ message.author.name }}
          </JText>

          <slot />
        </div>
      </JKeyboardNavItem>
    </template>

    <UserProfile :user="message.author" />
  </JMenu>
</template>

<script lang="ts" setup>
import { PropType, mergeProps } from 'vue';
import { JKeyboardNavItem, JText, JMenu } from '@new-jira-clone/ui/src/components';
import { UserProfile } from '@/features/user-profile';
import { IMessage } from '@/shared';
import MessageTime from './MessageTime.vue';

defineProps({
  message: {
    type: Object as PropType<IMessage>,
    required: true,
  },
  hideAuthor: {
    type: Boolean,
    default: false,
  },
});
</script>

<style lang="scss" scoped>
.chat-system-message {
  display: flex;
  justify-content: center;
  align-items: center;
  position: relative;
}

.author-chat-message {
  &:focus-visible::before {
    content: '';
    position: absolute;
    left: 0;
    width: 100%;
    height: 100%;
    outline: var(--j-focus-outline);
  }
}

.time {
  margin-top: 1px;
  margin-right: 10px;
}

.author-chat-message {
  margin-right: 4px;
  cursor: pointer;
}
</style>
